
#include "glframewindow.h"
#include <stdlib.h>

#define MENU_HEIGHT 30

GLFrameWindow::GLFrameWindow(int width, int height, const char *title) 
	: Fl_Window(width, height, title), 
	  menubar(0, 0, width, MENU_HEIGHT), 
	  glwindow(0, MENU_HEIGHT, width, height){

	// make the gl area resize with the frame window
    resizable(glwindow);

	// 
	end();
};

GLFrameWindow::GLWindow::GLWindow(int x, int y, int width, int height)
	: Fl_Gl_Window (x, y, width, height, "glwindow"){
}

// forward calls to GLFrameWindow
void GLFrameWindow::GLWindow::draw() {
	GLFrameWindow* frameparent = (GLFrameWindow*)parent();

	// the opengl context has been created, set rendering options
	if (!valid()) {
		frameparent->OnGLInit();
	}

	// draw stuff usign opengl
	frameparent->OnGLDraw();
}

// forward calls to GLFrameWindow
int GLFrameWindow::GLWindow::handle(int event) {
	if(Fl_Gl_Window::handle(event) == 1)
		return 1;

	GLFrameWindow* frameparent = (GLFrameWindow*)parent();
	return frameparent->handleForGLArea(event);
}

